import { Injectable } from '@nestjs/common';
import { AdRepository } from '../../../database/domain/ad-repository';
import { Ad } from '../../domain/entities/ad';
import { DatabaseException } from '../../../database/exceptions/database.exception';
import { Prisma } from '@prisma/client';
@Injectable()
export class AdsRepository extends AdRepository<Ad> {
  protected _model = 'ad';

  async create(entity: Partial<Ad> | any, include?: any): Promise<Ad> {
    console.log('custom ad repo ');
    console.log(entity);
    console.log('*****************************************');
    try {
      const res = await this._prisma[this._model].create({
        data: entity,
        include: include,
      });
      return res;
    } catch (e) {
      console.log('repo error ');
      console.log(e);
      if (e instanceof Prisma.PrismaClientKnownRequestError) {
        throw new DatabaseException(
          Prisma.PrismaClientKnownRequestError.name,
          e.code,
          e.message,
        );
      } else {
        throw new DatabaseException();
      }
    }
  }
}
